"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmplifyPublishDialog = void 0;
var react_1 = __importDefault(require("react"));
// eslint-disable-next-line import/no-extraneous-dependencies
var core_1 = require("@blueprintjs/core");
var fs_extra_1 = __importDefault(require("fs-extra"));
var client_amplify_1 = require("@aws-sdk/client-amplify");
var constants_1 = require("./constants");
var preferences_1 = require("./preferences");
var utils_1 = require("./utils");
var amplifyUtils_1 = require("./amplifyUtils");
var inputDialog_1 = require("./inputDialog");
var overwriteDialog_1 = require("./overwriteDialog");
var progressDialog_1 = require("./progressDialog");
var successDialog_1 = require("./successDialog");
var failureDialog_1 = require("./failureDialog");
/**
 * This dialog component handles allowing the user to input any Amplify-related configuration
 * before pressing a button to publish their BabylonJS project. The configuration will be
 * persisted in the workspace.
 */
var AmplifyPublishDialog = /** @class */ (function (_super) {
    __extends(AmplifyPublishDialog, _super);
    function AmplifyPublishDialog(props) {
        var _this = _super.call(this, props) || this;
        /**
         * Handle the close button when clicked
         */
        _this._handleCloseClick = function () {
            preferences_1.setAmplifyPublishingPreferences(__assign({}, _this.state));
            _this.setState({ status: constants_1.Status.Publish });
            var handleClose = _this.props.handleClose;
            handleClose();
        };
        /**
         * Handle the publish button when clicked
         * @param appName The Amplify application name.
         * @param envName The Amplify environment name.
         * @returns A Promise that resolves when the scene publishing process completes..
         * Otherwise, it will change to render the failure dialog with the
         * error message.
         */
        _this._handlePublishClick = function (appName, envName) { return __awaiter(_this, void 0, void 0, function () {
            var appId, doesBranchExist, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 9, , 10]);
                        if (!this.props.editor.scene) {
                            throw new Error('No active scene to publish!');
                        }
                        return [4 /*yield*/, amplifyUtils_1.getExistingAmplifyAppId(appName, this.client)];
                    case 1:
                        appId = _a.sent();
                        if (!(appId === null || appId === undefined)) return [3 /*break*/, 3];
                        return [4 /*yield*/, amplifyUtils_1.createAmplifyApp(appName, this.client)];
                    case 2:
                        appId = _a.sent();
                        _a.label = 3;
                    case 3:
                        if (appId === undefined) {
                            throw new Error("The created app has an undefined appId.");
                        }
                        return [4 /*yield*/, amplifyUtils_1.checkExistingAmplifyBranch(appId, envName, this.client)];
                    case 4:
                        doesBranchExist = _a.sent();
                        if (!!doesBranchExist) return [3 /*break*/, 6];
                        return [4 /*yield*/, amplifyUtils_1.createAmplifyBranch(appId, envName, this.client)];
                    case 5:
                        _a.sent();
                        return [3 /*break*/, 7];
                    case 6:
                        this.setState({ status: constants_1.Status.ExistBranch });
                        return [2 /*return*/];
                    case 7: return [4 /*yield*/, this._publishToAmplify(appId, envName)];
                    case 8:
                        _a.sent();
                        return [3 /*break*/, 10];
                    case 9:
                        error_1 = _a.sent();
                        this.setState({ error: error_1, status: constants_1.Status.Failure });
                        return [3 /*break*/, 10];
                    case 10: return [2 /*return*/];
                }
            });
        }); };
        /**
         * Publish the files to AWS Amplify.
         * @param appId The Amplify application Id.
         * @param envName The Amplify environment name.
         * @returns A Promise that resolves when publishing the scene to Amplify
         * and change to render the SuccessDialog. Otherwise, it will throw
         * the error to the upper level.
         * @throws An error once the url used to upload the file is undefined.
         */
        _this._publishToAmplify = function (appId, envName) { return __awaiter(_this, void 0, void 0, function () {
            var artifactsPath, _a, jobId, zipUploadUrl, domainAddress, errorMessage;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        this.setState({ status: constants_1.Status.Progress });
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, , 9, 10]);
                        return [4 /*yield*/, utils_1.zipArtifacts('tmpDir')];
                    case 2:
                        artifactsPath = _b.sent();
                        return [4 /*yield*/, amplifyUtils_1.createAmplifyDeployment(appId, envName, this.client)];
                    case 3:
                        _a = _b.sent(), jobId = _a.jobId, zipUploadUrl = _a.zipUploadUrl;
                        if (jobId === undefined) {
                            throw new Error('The Job Id is undefined. Please try it again!');
                        }
                        if (!zipUploadUrl) return [3 /*break*/, 5];
                        return [4 /*yield*/, utils_1.httpPutFile(artifactsPath, zipUploadUrl)];
                    case 4:
                        _b.sent();
                        return [3 /*break*/, 6];
                    case 5: throw new Error('The url used to upload the file is undefined.');
                    case 6: return [4 /*yield*/, amplifyUtils_1.startAmplifyDeployment(appId, envName, jobId, this.client)];
                    case 7:
                        _b.sent();
                        return [4 /*yield*/, amplifyUtils_1.waitJobToSucceed(appId, envName, jobId, this.client)];
                    case 8:
                        _b.sent();
                        domainAddress = utils_1.getDefaultDomainForBranch(appId, envName);
                        this.setState({ domainAddress: domainAddress, status: constants_1.Status.Success });
                        this.props.editor.console.logInfo(domainAddress);
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (artifactsPath) {
                                fs_extra_1.default.unlinkSync(artifactsPath);
                            }
                        }
                        catch (error) {
                            errorMessage = "An error has occurred while removing the compressed file at " + artifactsPath + ". Please remove it manually. " + error;
                            this.setState({ error: errorMessage, status: constants_1.Status.Failure });
                        }
                        return [7 /*endfinally*/];
                    case 10: return [2 /*return*/];
                }
            });
        }); };
        /**
         * overwrite the branch to AWS Amplify application.
         * @param appName The Amplify application name.
         * @param envName The Amplify environment name.
         * @returns A Promise that resolves when the scene publishing process completes.
         * Otherwise, it will reject and change to render the Failure dialog
         * with error message.
         */
        _this._overwriteAmplifyBranch = function (appName, envName) { return __awaiter(_this, void 0, void 0, function () {
            var appId, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 5, , 6]);
                        return [4 /*yield*/, amplifyUtils_1.getExistingAmplifyAppId(appName, this.client)];
                    case 1:
                        appId = _a.sent();
                        if (!appId) return [3 /*break*/, 3];
                        return [4 /*yield*/, this._publishToAmplify(appId, envName)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3: throw new Error("The appId isn't valid.");
                    case 4: return [3 /*break*/, 6];
                    case 5:
                        error_2 = _a.sent();
                        this.setState({ error: error_2, status: constants_1.Status.Failure });
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        }); };
        /**
         * Handle the back button when clicked.
         */
        _this._handleBackClick = function () {
            _this.setState({ status: constants_1.Status.Publish });
        };
        // grab the local preferences and set them in the local state
        // so they can be referenced as the default values in the render() function
        var preferences = preferences_1.getAmplifyPublishingPreferences();
        _this.state = {
            appName: preferences.appName,
            envName: preferences.envName,
            status: constants_1.Status.Publish,
            domainAddress: '',
            error: '',
        };
        _this.client = new client_amplify_1.AmplifyClient({ customUserAgent: "AWSToolsForBabylonJS-" + constants_1.PLUGIN_VERSION });
        return _this;
    }
    AmplifyPublishDialog.prototype.render = function () {
        var _this = this;
        var isOpen = this.props.isOpen;
        var _a = this.state, status = _a.status, appName = _a.appName, envName = _a.envName, domainAddress = _a.domainAddress, error = _a.error;
        return (react_1.default.createElement(core_1.Dialog, { isOpen: isOpen, autoFocus: true, usePortal: false, canOutsideClickClose: false, enforceFocus: true, transitionDuration: 1000 },
            status === constants_1.Status.Publish && (react_1.default.createElement(inputDialog_1.InputDialog, { appName: appName, envName: envName, onAppNameChange: function (newAppName) {
                    return _this.setState({ appName: newAppName });
                }, onEnvNameChange: function (newEnvName) {
                    return _this.setState({ envName: newEnvName });
                }, onPublish: this._handlePublishClick, onClose: this._handleCloseClick })),
            status === constants_1.Status.ExistBranch && (react_1.default.createElement(overwriteDialog_1.OverwriteDialog, { appName: appName, envName: envName, onBack: this._handleBackClick, onOverwrite: this._overwriteAmplifyBranch })),
            status === constants_1.Status.Progress && react_1.default.createElement(progressDialog_1.ProgressDialog, null),
            status === constants_1.Status.Success && (react_1.default.createElement(successDialog_1.SuccessDialog, { appName: appName, envName: envName, domainAddress: domainAddress, onClose: this._handleCloseClick })),
            status === constants_1.Status.Failure && (react_1.default.createElement(failureDialog_1.FailureDialog, { error: error, onBack: this._handleBackClick }))));
    };
    return AmplifyPublishDialog;
}(react_1.default.Component));
exports.AmplifyPublishDialog = AmplifyPublishDialog;
//# sourceMappingURL=amplifyPublishDialog.js.map