"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FailureDialog = void 0;
var react_1 = __importDefault(require("react"));
// eslint-disable-next-line import/no-extraneous-dependencies
var core_1 = require("@blueprintjs/core");
/**
 * The dialog to show the failure information.
 * @param props The props passed in from the parent component
 * @returns the FailureDialog component.
 */
function FailureDialog(props) {
    var error = props.error, onBack = props.onBack;
    var failureTitle = "There was a problem!";
    var failureText = "" + error;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_BODY },
            react_1.default.createElement("p", null,
                react_1.default.createElement(core_1.Icon, { icon: "cross", intent: core_1.Intent.NONE }),
                " ",
                failureTitle),
            react_1.default.createElement("p", { style: { overflowWrap: 'break-word' } }, failureText)),
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER },
            react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER_ACTIONS },
                react_1.default.createElement(core_1.Button, { onClick: onBack }, "Back")))));
}
exports.FailureDialog = FailureDialog;
//# sourceMappingURL=failureDialog.js.map