"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputDialog = void 0;
var react_1 = __importDefault(require("react"));
// eslint-disable-next-line import/no-extraneous-dependencies
var core_1 = require("@blueprintjs/core");
/**
 * The dialog to show the input when publishing to Amplify.
 * @param props The props passed in from the parent component.
 * @returns the InputDialog component.
 */
function InputDialog(props) {
    var appName = props.appName, envName = props.envName, onPublish = props.onPublish, onAppNameChange = props.onAppNameChange, onEnvNameChange = props.onEnvNameChange, onClose = props.onClose;
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_BODY },
            react_1.default.createElement(core_1.FormGroup, null,
                react_1.default.createElement(core_1.Label, null,
                    "App Name",
                    react_1.default.createElement("input", { onChange: function (evt) {
                            onAppNameChange(evt.target.value);
                        }, value: appName, className: core_1.Classes.INPUT, minLength: 3, maxLength: 1024, id: "amplify-app-name", name: "amplify-app-name" })),
                react_1.default.createElement(core_1.Label, null,
                    "Environment name (dev, test, prod, ...)",
                    react_1.default.createElement("input", { onChange: function (evt) { return onEnvNameChange(evt.target.value); }, value: envName, className: core_1.Classes.INPUT, minLength: 1, maxLength: 255, id: "amplify-env-name", name: "amplify-env-name" })))),
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER },
            react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER_ACTIONS },
                react_1.default.createElement(core_1.Button, { onClick: onClose }, "Close"),
                react_1.default.createElement(core_1.Button, { onClick: function () { return onPublish(appName, envName); }, disabled: !appName || !envName, type: "submit" }, "Publish")))));
}
exports.InputDialog = InputDialog;
//# sourceMappingURL=inputDialog.js.map