"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OverwriteDialog = void 0;
var react_1 = __importDefault(require("react"));
// eslint-disable-next-line import/no-extraneous-dependencies
var core_1 = require("@blueprintjs/core");
/**
 * The dialog to show the whether overwrite the branch.
 * @param props The props passed in from the parent component.
 * @returns the OverwriteDialog component.
 */
function OverwriteDialog(props) {
    var appName = props.appName, envName = props.envName, onBack = props.onBack, onOverwrite = props.onOverwrite;
    var overwriteText = "An application is already deployed to " + appName + "(" + envName + "). Overwrite?";
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_BODY },
            react_1.default.createElement(core_1.Text, null, overwriteText)),
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER },
            react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER_ACTIONS },
                react_1.default.createElement(core_1.Button, { onClick: onBack }, "Back"),
                react_1.default.createElement(core_1.Button, { onClick: function () { return onOverwrite(appName, envName); } }, "Overwrite")))));
}
exports.OverwriteDialog = OverwriteDialog;
//# sourceMappingURL=overwriteDialog.js.map