"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setAmplifyPublishingPreferences = exports.getAmplifyPublishingPreferences = void 0;
/**
 * The saved preferences (declared inline with default values) for the plugin
 */
var preferences = {
    appName: '',
    envName: '',
};
/**
 * Exports the preferences of the plugin to a dictionary.
 * @returns A dictionary containing the values defined by AmplifyPublishingPreferences
 */
exports.getAmplifyPublishingPreferences = function () { return (__assign({}, preferences)); };
/**
 * Imports the preferences of the plugin from its JSON representation.
 */
exports.setAmplifyPublishingPreferences = function (config) {
    preferences.appName = config.appName;
    preferences.envName = config.envName;
};
//# sourceMappingURL=preferences.js.map