"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SuccessDialog = void 0;
var react_1 = __importDefault(require("react"));
// eslint-disable-next-line import/no-extraneous-dependencies
var core_1 = require("@blueprintjs/core");
/**
 * The dialog to show the successful deployment information.
 * @param props The props passed in from the parent component.
 * @returns the SuccessDialog component.
 */
function SuccessDialog(props) {
    var appName = props.appName, envName = props.envName, domainAddress = props.domainAddress, onClose = props.onClose;
    var successTitle = "Deployment complete.";
    var successText = appName + " (" + envName + ")";
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_BODY },
            react_1.default.createElement("p", null,
                react_1.default.createElement(core_1.Icon, { icon: "tick", intent: core_1.Intent.NONE }),
                " ",
                successTitle),
            react_1.default.createElement(core_1.Text, null, successText),
            react_1.default.createElement(core_1.Text, null, domainAddress)),
        react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER },
            react_1.default.createElement("div", { className: core_1.Classes.DIALOG_FOOTER_ACTIONS },
                react_1.default.createElement(core_1.Button, { onClick: onClose }, "Done")))));
}
exports.SuccessDialog = SuccessDialog;
//# sourceMappingURL=successDialog.js.map