"use strict";
// Copyright Amazon.com, Inc. or its affiliates. All Rights Reserved.
// SPDX-License-Identifier: Apache-2.0
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AmplifyPublisherToolbar = void 0;
var react_1 = __importDefault(require("react"));
// eslint-disable-next-line import/no-extraneous-dependencies
var core_1 = require("@blueprintjs/core");
var amplifyPublishDialog_1 = require("./amplifyPublishDialog");
/**
 * The Amplify toolbar is a single button that, when clicked, shows a drop-down menu
 * of helpful tools and dialogs that allow the user to interact with AWS.
 */
var AmplifyPublisherToolbar = /** @class */ (function (_super) {
    __extends(AmplifyPublisherToolbar, _super);
    function AmplifyPublisherToolbar(props) {
        var _this = _super.call(this, props) || this;
        _this._handleClose = function () {
            _this._hidePublishDialog();
        };
        _this._handlePublishClick = function () {
            _this._showPublishDialog();
        };
        _this.state = {
            isPublishDialogOpen: false,
        };
        return _this;
    }
    AmplifyPublisherToolbar.prototype._showPublishDialog = function () {
        this.setState({ isPublishDialogOpen: true });
    };
    AmplifyPublisherToolbar.prototype._hidePublishDialog = function () {
        this.setState({ isPublishDialogOpen: false });
    };
    AmplifyPublisherToolbar.prototype.render = function () {
        var editor = this.props.editor;
        var isPublishDialogOpen = this.state.isPublishDialogOpen;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(core_1.Menu, null,
                react_1.default.createElement(core_1.MenuItem, { text: "AWS Amplify Hosting", onClick: this._handlePublishClick, shouldDismissPopover: false })),
            react_1.default.createElement(amplifyPublishDialog_1.AmplifyPublishDialog, { editor: editor, isOpen: isPublishDialogOpen, handleClose: this._handleClose })));
    };
    return AmplifyPublisherToolbar;
}(react_1.default.Component));
exports.AmplifyPublisherToolbar = AmplifyPublisherToolbar;
//# sourceMappingURL=toolbar.js.map